<?php

namespace Drupal\Tests\commerce_product_reservation\FunctionalJavascript;

use Drupal\FunctionalJavascriptTests\WebDriverTestBase;

/**
 * Javascript tests for this.
 *
 * @group commerce_product_reservation
 * @group legacy
 */
class CheckoutFlowTest extends WebDriverTestBase {

  /**
   * {@inheritdoc}
   */
  protected $defaultTheme = 'stark';

  /**
   * {@inheritdoc}
   */
  protected $failOnJavascriptConsoleErrors = FALSE;

  /**
   * Admin user.
   *
   * @var \Drupal\user\Entity\User|false
   */
  protected $adminUser;

  /**
   * Modules to enable.
   *
   * @var array
   */
  protected static $modules = [
    'commerce_product_reservation',
    'commerce_tax',
  ];

  /**
   * {@inheritdoc}
   */
  public function setUp() : void {
    parent::setUp();
    $this->adminUser = $this->createUser(['administer commerce_checkout_flow']);
  }

  /**
   * Test the fact that we have a checkout flow for reservations.
   */
  public function testCheckoutFlowExists() {
    if (version_compare(\Drupal::VERSION, '10.0.0', '<') && method_exists($this, 'expectDeprecation')) {
      // Drupal 9 supports PHPUnit 8 or 9.
      $this->expectDeprecation();
      $this->expectDeprecationMessageMatches('/jQuery\.once\(\) is deprecated/');
    }

    $this->drupalLogin($this->adminUser);
    $this->drupalGet('admin/commerce/config/checkout-flows/manage/reservation');
    $this->assertSession()->elementExists('css', '#commerce-checkout-flow-edit-form');
  }

}
